/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.dns.models;

import com.microsoft.windowsazure.core.ResourceBaseExtended;

/**
* Describes a DNS zone.
*/
public class Zone extends ResourceBaseExtended {
    private String eTag;
    
    /**
    * Optional. Gets or sets the ETag of the zone that is being updated, as
    * received from a Get operation.
    * @return The ETag value.
    */
    public String getETag() {
        return this.eTag;
    }
    
    /**
    * Optional. Gets or sets the ETag of the zone that is being updated, as
    * received from a Get operation.
    * @param eTagValue The ETag value.
    */
    public void setETag(final String eTagValue) {
        this.eTag = eTagValue;
    }
    
    private ZoneProperties properties;
    
    /**
    * Optional. Gets or sets the properties of the zone.
    * @return The Properties value.
    */
    public ZoneProperties getProperties() {
        return this.properties;
    }
    
    /**
    * Optional. Gets or sets the properties of the zone.
    * @param propertiesValue The Properties value.
    */
    public void setProperties(final ZoneProperties propertiesValue) {
        this.properties = propertiesValue;
    }
    
    /**
    * Initializes a new instance of the Zone class.
    *
    */
    public Zone() {
        super();
    }
    
    /**
    * Initializes a new instance of the Zone class with required arguments.
    *
    * @param location Gets or sets the location of the resource.
    */
    public Zone(String location) {
        this();
        if (location == null) {
            throw new NullPointerException("location");
        }
        this.setLocation(location);
    }
}
