/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.network.models;

import com.microsoft.windowsazure.core.LazyArrayList;
import com.microsoft.windowsazure.core.OperationResponse;

import java.util.ArrayList;

/**
* Response for ListPublicIpAddresses Api service call
*/
public class PublicIpAddressListResponse extends OperationResponse {
    private String nextLink;
    
    /**
    * Optional. Gets the URL to get the next set of results.
    * @return The NextLink value.
    */
    public String getNextLink() {
        return this.nextLink;
    }
    
    /**
    * Optional. Gets the URL to get the next set of results.
    * @param nextLinkValue The NextLink value.
    */
    public void setNextLink(final String nextLinkValue) {
        this.nextLink = nextLinkValue;
    }
    
    private ArrayList<PublicIpAddress> publicIpAddresses;
    
    /**
    * Optional. Gets List of publicIP addresses that exists in a resource group
    * @return The PublicIpAddresses value.
    */
    public ArrayList<PublicIpAddress> getPublicIpAddresses() {
        return this.publicIpAddresses;
    }
    
    /**
    * Optional. Gets List of publicIP addresses that exists in a resource group
    * @param publicIpAddressesValue The PublicIpAddresses value.
    */
    public void setPublicIpAddresses(final ArrayList<PublicIpAddress> publicIpAddressesValue) {
        this.publicIpAddresses = publicIpAddressesValue;
    }
    
    /**
    * Initializes a new instance of the PublicIpAddressListResponse class.
    *
    */
    public PublicIpAddressListResponse() {
        super();
        this.setPublicIpAddresses(new LazyArrayList<PublicIpAddress>());
    }
}
