/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.sql.models;

import com.microsoft.windowsazure.core.OperationResponse;
import com.microsoft.windowsazure.core.OperationStatus;

/**
* Response for long running Azure Sql Database Elastic Pool operation.
*/
public class ElasticPoolCreateOrUpdateResponse extends OperationResponse {
    private ElasticPool elasticPool;
    
    /**
    * Optional. Gets or sets Elastic Pool object that represents the Azure Sql
    * Database Elastic Pool.
    * @return The ElasticPool value.
    */
    public ElasticPool getElasticPool() {
        return this.elasticPool;
    }
    
    /**
    * Optional. Gets or sets Elastic Pool object that represents the Azure Sql
    * Database Elastic Pool.
    * @param elasticPoolValue The ElasticPool value.
    */
    public void setElasticPool(final ElasticPool elasticPoolValue) {
        this.elasticPool = elasticPoolValue;
    }
    
    private ErrorResponse error;
    
    /**
    * Optional.
    * @return The Error value.
    */
    public ErrorResponse getError() {
        return this.error;
    }
    
    /**
    * Optional.
    * @param errorValue The Error value.
    */
    public void setError(final ErrorResponse errorValue) {
        this.error = errorValue;
    }
    
    private String operationStatusLink;
    
    /**
    * Optional.
    * @return The OperationStatusLink value.
    */
    public String getOperationStatusLink() {
        return this.operationStatusLink;
    }
    
    /**
    * Optional.
    * @param operationStatusLinkValue The OperationStatusLink value.
    */
    public void setOperationStatusLink(final String operationStatusLinkValue) {
        this.operationStatusLink = operationStatusLinkValue;
    }
    
    private int retryAfter;
    
    /**
    * Optional.
    * @return The RetryAfter value.
    */
    public int getRetryAfter() {
        return this.retryAfter;
    }
    
    /**
    * Optional.
    * @param retryAfterValue The RetryAfter value.
    */
    public void setRetryAfter(final int retryAfterValue) {
        this.retryAfter = retryAfterValue;
    }
    
    private OperationStatus status;
    
    /**
    * Optional.
    * @return The Status value.
    */
    public OperationStatus getStatus() {
        return this.status;
    }
    
    /**
    * Optional.
    * @param statusValue The Status value.
    */
    public void setStatus(final OperationStatus statusValue) {
        this.status = statusValue;
    }
}
