/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.compute.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* Specifies the SSH public keys and key pairs to populate in the image during
* provisioning. This element is only used with the
* LinuxProvisioningConfiguration set.
*/
public class SshSettings {
    private ArrayList<SshSettingKeyPair> keyPairs;
    
    /**
    * Optional. Specifies the collection of SSH key pairs.
    * @return The KeyPairs value.
    */
    public ArrayList<SshSettingKeyPair> getKeyPairs() {
        return this.keyPairs;
    }
    
    /**
    * Optional. Specifies the collection of SSH key pairs.
    * @param keyPairsValue The KeyPairs value.
    */
    public void setKeyPairs(final ArrayList<SshSettingKeyPair> keyPairsValue) {
        this.keyPairs = keyPairsValue;
    }
    
    private ArrayList<SshSettingPublicKey> publicKeys;
    
    /**
    * Optional. Specifies the collection of SSH public keys.
    * @return The PublicKeys value.
    */
    public ArrayList<SshSettingPublicKey> getPublicKeys() {
        return this.publicKeys;
    }
    
    /**
    * Optional. Specifies the collection of SSH public keys.
    * @param publicKeysValue The PublicKeys value.
    */
    public void setPublicKeys(final ArrayList<SshSettingPublicKey> publicKeysValue) {
        this.publicKeys = publicKeysValue;
    }
    
    /**
    * Initializes a new instance of the SshSettings class.
    *
    */
    public SshSettings() {
        this.setKeyPairs(new LazyArrayList<SshSettingKeyPair>());
        this.setPublicKeys(new LazyArrayList<SshSettingPublicKey>());
    }
}
