/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.servicebus.models;

import com.microsoft.windowsazure.core.LazyArrayList;
import com.microsoft.windowsazure.core.OperationResponse;

import java.util.ArrayList;
import java.util.Iterator;

/**
* A response to a request for a list of namespaces.
*/
public class ServiceBusNamespaceDescriptionResponse extends OperationResponse implements Iterable<NamespaceDescription> {
    private ArrayList<NamespaceDescription> namespaceDescriptions;
    
    /**
    * Optional. The descriptions for the namespace.
    * @return The NamespaceDescriptions value.
    */
    public ArrayList<NamespaceDescription> getNamespaceDescriptions() {
        return this.namespaceDescriptions;
    }
    
    /**
    * Optional. The descriptions for the namespace.
    * @param namespaceDescriptionsValue The NamespaceDescriptions value.
    */
    public void setNamespaceDescriptions(final ArrayList<NamespaceDescription> namespaceDescriptionsValue) {
        this.namespaceDescriptions = namespaceDescriptionsValue;
    }
    
    /**
    * Initializes a new instance of the ServiceBusNamespaceDescriptionResponse
    * class.
    *
    */
    public ServiceBusNamespaceDescriptionResponse() {
        super();
        this.setNamespaceDescriptions(new LazyArrayList<NamespaceDescription>());
    }
    
    /**
    * Gets the sequence of NamespaceDescriptions.
    *
    */
    public Iterator<NamespaceDescription> iterator() {
        return this.getNamespaceDescriptions().iterator();
    }
}
