/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.websites.models;

/**
* The Authentication / Authorization settings of a web site.
*/
public class SiteAuthSettings {
    private String aADClientId;
    
    /**
    * Optional. Gets or sets the OpenID Connection client_id value for the web
    * site.
    * @return The AADClientId value.
    */
    public String getAADClientId() {
        return this.aADClientId;
    }
    
    /**
    * Optional. Gets or sets the OpenID Connection client_id value for the web
    * site.
    * @param aADClientIdValue The AADClientId value.
    */
    public void setAADClientId(final String aADClientIdValue) {
        this.aADClientId = aADClientIdValue;
    }
    
    private String openIdIssuer;
    
    /**
    * Optional. Gets or sets the OpenID Connect issuer URL value for the web
    * site.
    * @return The OpenIdIssuer value.
    */
    public String getOpenIdIssuer() {
        return this.openIdIssuer;
    }
    
    /**
    * Optional. Gets or sets the OpenID Connect issuer URL value for the web
    * site.
    * @param openIdIssuerValue The OpenIdIssuer value.
    */
    public void setOpenIdIssuer(final String openIdIssuerValue) {
        this.openIdIssuer = openIdIssuerValue;
    }
}
